#===========================================================================
# KoalaRainbow - a visualization system
# Copyright (C) 2004, Andrew Sutherland (sombrero@alum.mit.edu)
#
# KoalaRainbow is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#===========================================================================
package OnlyTheWind::KoalaRainbow::Environment;
use strict;

use OnlyTheWind::KoalaRainbow::ContextManager;

my $environment = {};

sub setval
{
    my ($classname, $key, $val) = @_;
    
    $environment->{$key} = [0, $val];
    
    return $val;
}

sub setset
{
    my ($classname, $key, $val) = @_;
    
    $environment->{$key} = [1, $val];
    
    return $val;
}

sub setany
{
    my ($classname, $key, $val) = @_;
    
    my $type = 0;
    if(ref($val) eq 'OnlyTheWind::KoalaRainbow::ContextManager')
    {
        $type = 1;
    }
    
    $environment->{$key} = [$type, $val];
    
    return $val;
}

sub getany
{
    my ($classname, $key) = @_;
    
    my $taggedValue = $environment->{$key};
    
    if(!defined $taggedValue)
    {
        return undef;
    }
    
    my $isSet = $taggedValue->[0];
    my $value = $taggedValue->[1];
    
    return $value;
}

sub getval
{
    my ($classname, $key) = @_;
    
    my $taggedValue = $environment->{$key};

    if(!defined $taggedValue)
    {
        return undef;
    }
    
    my $isSet = $taggedValue->[0];
    my $value = $taggedValue->[1];
    
    if($isSet)
    {
        return $value->nodes->[0];
    }
    else
    {
        return $value;
    }
}

sub getset
{
    my ($classname, $key) = @_;
    
    my $taggedValue = $environment->{$key};

    if(!defined $taggedValue)
    {
        return undef;
    }
    
    my $isSet = $taggedValue->[0];
    my $value = $taggedValue->[1];
    
    if($isSet)
    {
        return $value;
    }
    else
    {
        my $ctxMgr = OnlyTheWind::KoalaRainbow::ContextManager->new([$value]);
        return $ctxMgr;
    }
}
