#===========================================================================
# KoalaRainbow - a visualization system
# Copyright (C) 2004, Andrew Sutherland (sombrero@alum.mit.edu)
#
# KoalaRainbow is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#===========================================================================
package OnlyTheWind::KoalaRainbow::QueryParseNodes::ContextVariable;
use strict;

sub new
{
    my $class = shift;
    
    my $self  =
    {
        NAME  => undef,
    };
    
    bless ($self, $class);
    return $self;
}

sub name
{
    my $self = shift;
    
    if (@_) 
    {
        $self->{NAME} = shift;
    }
    
    return $self->{NAME};
}

sub toString
{
    my $self = shift;

    if($self->{NAME})
    {
        return '@' . $self->{NAME};
    }
    else
    {
        return 'unhappy context variable';
    }
}

sub isConstant
{
    return 0;
}

sub propagateConstraint
{
    return 0;
}

sub partialEvaluate
{
    # dude, we so can't do anything.
    return shift;
}

sub evaluate
{
    my ($self, $ctxMgr) = @_;
 
    my $varName = $self->{NAME};

    if($varName)
    {
        return $ctxMgr->evalEdge($varName);
    }
    else
    {
        return undef;
    }
}

sub evaluateSet
{
    my ($self, $ctxMgr) = @_;
    
    return $self->evaluate($ctxMgr);
}

sub evaluateValue
{
    my ($self, $ctxMgr) = @_;
    
    my $edgeSet = $self->evaluate($ctxMgr);
    
    return $edgeSet->[0];
}

sub clone
{
    return shift;
}

1;
