#===========================================================================
# KoalaRainbow - a visualization system
# Copyright (C) 2004, Andrew Sutherland (sombrero@alum.mit.edu)
#
# KoalaRainbow is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#===========================================================================
package OnlyTheWind::KoalaRainbow::QueryParseNodes::DerivedValue;
use strict;

sub new
{
    my $class = shift;
    
    # okay, we can just be a reference to said value, we are a constant after
    #  all.
    my $self  = \shift;
    
    bless ($self, $class);
    return $self;
}

sub isConstant
{
    return 1;
}

sub isScalar
{
    return 1;
}

sub getValue
{
    my $self = shift;
    # deref
    return $$self;
}

sub toString
{
    my $self = shift;
    # deref
    return '_' . $$self . '_';
}

sub propagateConstraint
{
    return 0;
}

sub partialEvaluate
{
    return shift;
}

sub evaluate
{
    my $self = shift;
    # deref
    return $$self;
}

sub evaluateValue
{
    my $self = shift;
    # deref
    return $$self;
}

sub evaluateSet
{
    my $self = shift;
    # deref
    return $$self;
}

1;
