#!/usr/bin/perl -w
# -d:DProf
# Note that the following code is basically a required idiom of use of the
#  movable type framework for cgi purposes.  As such, this code is derived from
#  mt.cgi, although prettified to meet my coding style sensibilities.  No
#  copyright is claimed on this code, and the derivation is felt acceptable
#  on the basis that this file only exists in order to integrate the rest of
#  koalaRainbow with the movabletype system.

use strict;

my($MT_DIR);
BEGIN
{
    # uh, so we need to be somewhere under plugins... 
    if ($0 =~ m!(.*[/\\])plugins!)
    {
        $MT_DIR = $1;
    }
    else
    {
        $MT_DIR = './';
    }
    unshift @INC, $MT_DIR . 'lib';
    unshift @INC, $MT_DIR . 'extlib';

}

eval
{
    require OnlyTheWind::KoalaRainbow::WebGui;
    my $app = OnlyTheWind::KoalaRainbow::WebGui->new( 
                  Config => $MT_DIR . 'mt.cfg',
                  Directory => $MT_DIR )
        or die OnlyTheWind::KoalaRainbow::WebGui->errstr;
        
    local $SIG{__WARN__} = sub { $app->trace($_[0]) };
    $app->run;
};

if ($@)
{
    print "Content-Type: text/html\n\n";
    print "Got an error: <pre>$@</pre>";
}
